@use "sass:map";
@use "../core/" as adm;

$name: 'adm-chip';
$component-tokens: (
	#{$name}: (
		default: (
			// backgrounds
			background: #ccc,
            background-hover: adm.component-token($name, 'background'),
            background-focus: adm.component-token($name, 'background'),
			
			background-selected: #999,
			background-selected-hover: adm.component-token($name, 'background-selected'),
			background-selected-focus: adm.component-token($name, 'background-selected'),

			// texts
            text: #000,
            text-hover: adm.component-token($name, 'text'),
            text-focus: adm.component-token($name, 'text'),
			text-selected: #000,
            text-selected-hover: adm.component-token($name, 'text-selected'),
            text-selected-focus: adm.component-token($name, 'text-selected'),

			// borders
            border: none,
			border-hover: adm.component-token($name, 'border'),
			border-focus: adm.component-token($name, 'border'),
			border-selected: none,
			border-selected-hover: adm.component-token($name, 'border-selected'),
			border-selected-focus: adm.component-token($name, 'border-selected'),

			// outlines for focus
			outline: none,
			outline-offset: 0,

			// misc
            padding-x: 20px,
            padding-y: 10px,
            radius: 40px,
            gap: 0.5rem,

			// size
            width: auto,
            height: auto,
            
			// type
			font-family: inherit,
            font-weight: 400,
            font-size: inherit,
            line-height: inherit,

		),
	),
) !default;

//@include adm.generate-component-tokens($component-tokens, '.adm-button');

@mixin generate-component-markup() {

	:host {
		display: inline-flex;
		box-sizing: border-box;
	}

	.#{$name} {
		
		position: relative;
		display: inline-flex;
		align-items: center;
		justify-content: center;
		text-decoration: none;
		box-sizing: border-box;

		background: adm.component-token($name, 'background');
		color: adm.component-token($name, 'text');
		border: adm.component-token($name, 'border');
		outline: adm.component-token($name, 'outline');
		outline-offset: adm.component-token($name, 'outline-offset');

		padding-left: adm.component-token($name, 'padding-x');
		padding-right: adm.component-token($name, 'padding-x');
		padding-top: adm.component-token($name, 'padding-y');
		padding-bottom: adm.component-token($name, 'padding-y');

		height: adm.component-token($name, 'height');
		width: adm.component-token($name, 'width');
		border-radius: adm.component-token($name, 'radius');

		font-family: adm.component-token($name, 'font-family');
		font-weight: adm.component-token($name, 'font-weight');
		font-size: adm.component-token($name, 'font-size');
		line-height: adm.component-token($name, 'line-height');
		
		gap: adm.component-token($name, 'gap');
		
		&:hover {
			background: adm.component-token($name, 'background-hover');
			color: adm.component-token($name, 'text-hover');
			border: adm.component-token($name, 'border-hover');
			outline: adm.component-token($name, 'outline-hover');
		}
		&:focus-visible {
			background: adm.component-token($name, 'background-focus');
			color: adm.component-token($name, 'text-focus');
			border: adm.component-token($name, 'border-focus');
			outline: adm.component-token($name, 'outline-focus');
		}

		&[selected] {
			
			background: adm.component-token($name, 'background-selected');
			color: adm.component-token($name, 'text-selected');
			border: adm.component-token($name, 'border-selected');

			&:hover {
				background: adm.component-token($name, 'background-selected-hover');
				color: adm.component-token($name, 'text-selected-hover');
				border: adm.component-token($name, 'border-selected-hover');
			}
			&:focus-visible {
				background: adm.component-token($name, 'background-selected-focus');
				color: adm.component-token($name, 'text-selected-focus');
				border: adm.component-token($name, 'border-selected-focus');
			}
		}
	}

	:host([disabled]),
    [disabled] {
        opacity: 0.4;
        pointer-events: none;
    }

	
	// individual code
	@content;

}